package com.sample;

import java.util.HashMap;
import java.util.Map;

import org.drools.runtime.StatefulKnowledgeSession;
import org.drools.runtime.process.ProcessInstance;
import org.drools.runtime.process.WorkItem;

public class DataAssociationTest extends JbpmJUnitTestCase {

	public DataAssociationTest(){
		super(false);//No persistence
	}
	
	public void testPassDataByCallActivity(){
		StatefulKnowledgeSession ksession=createKnowledgeSession("superProcessDataObject.bpmn2","subProcessDataObject.bpmn2");
		TestWorkItemHandler wiHandler=new TestWorkItemHandler();
		ksession.getWorkItemManager().registerWorkItemHandler("Human Task", wiHandler);
		
		Map<String, Object> params=new HashMap<String, Object>();
		params.put("superProcessPropertyIn", "Which is the history of Vittoria cow?");
		ProcessInstance instance=ksession.startProcess("superProcessDataObject",params);
		
		assertProcessInstanceActive(instance.getId(), ksession);
		assertNodeTriggered(instance.getId(), "Start","inScript","subProcessDataObject");
		assertNodeActive(instance.getId(), ksession, "subProcessDataObject");
		WorkItem workItem=wiHandler.getWorkItem();
		assertNotNull(workItem);
		System.out.println(workItem);
		assertNotNull(workItem.getParameter("subUserTaskDataIn"));
		assertEquals("Which is the history of Vittoria cow?",workItem.getParameter("subUserTaskDataIn"));
		
	
		params.clear();
		ksession.getWorkItemManager().completeWorkItem(workItem.getId(), params);
		
		assertProcessInstanceCompleted(instance.getId(), ksession);
	}
}
